/* Copyright (C) 2019 Terence Kelly.  All rights reserved.
   Minimalist relocatable persistent linked list. */

#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include "pmem.h"

typedef struct {
  pmo_t next;
  char string[];
} node_t;

#define NP(o)  ((node_t *)pmem_o2p(o))

int main(int argc, char *argv[]) {
  int r;
  char buf[100];  /* harmonize with scanf() below */
  pmo_t head, t;
  if (2 != argc) {
    fprintf(stderr, "usage: %s pmemfile\n", argv[0]);
    return 1;
  }
  if (0 != (r = pmem_map(argv[1]))) {
    fprintf(stderr, "pmem_map() failed: %d\n", r);
    return 2;
  }
  head = pmem_get_root();
  while (1 == scanf(" %99s", buf)) {
    if (0 == strcmp("[dump]", buf))
      for (t = head; 0 != t; t = NP(t)->next)
        printf("%s\n", NP(t)->string);
    else {
      t = pmem_alloc(sizeof(node_t) + 1 + strlen(buf));
      if (0 == t) {
        fprintf(stderr, "pmem_alloc() failed\n");
        return 3;
      }
      strcpy(NP(t)->string, buf);
      NP(t)->next = head;
      head = t;
      pmem_set_root(head);
    }
  }
  return 0;
}
